﻿using System;
using NUnit.Framework;
using SmallMvvm.Core.Datatypes;

namespace SmallMvvm.Core.UnitTests.Datatypes._StringExtensions
{
    [TestFixture]
    public class ReverseFixture
    {
        [Test]
        public void Usage()
        {
            string str = "Hello World!";
            str = str.Reverse();

            Assert.That(str, Is.EqualTo("!dlroW olleH"));
        }

        [Test]
        public void UsageWithEmpty()
        {
            const string STR1 = "";
            string str2 = STR1.Reverse();

            Assert.That(str2, Is.EqualTo(STR1));
            Assert.That(str2, Is.EqualTo(""));
        }

        [Test, SetUICulture("en-US")]
        public void WillThrowNullReferenceException()
        {
            string str = null;
            NullReferenceException exception = Assert.Throws<NullReferenceException>(() => str.Reverse());

            Assert.That(exception.GetType(), Is.EqualTo(typeof(NullReferenceException)));
            Assert.That(exception.Message, Is.EqualTo("Object reference not set to an instance of an object."));
        }
    }
}