﻿using System;
using System.Linq.Expressions;
using SmallMvvm.Core.Property;

namespace SmallMvvm.Core.UnitTests.Property._ExtendedPropertyBase
{
    internal class ExtendedPropertyTestClass : ExtendedPropertyBase
    {
        #region Get

        #if !NET20 && !NET30

        internal new T Get<T>(Expression<Func<T>> expression, T defaultValue = default(T))
        {
            return base.Get(expression, defaultValue);
        }

        internal new T Get<T>(string propertyName, T defaultValue = default(T))
        {
            return base.Get(propertyName, defaultValue);
        }

        #endif

        #endregion

        #region Set

        #if !NET20 && !NET30

        internal new void Set<T>(Expression<Func<T>> expression, T value)
        {
            base.Set(expression, value);
        }

        internal new void Set<T>(string propertyName, T value)
        {
            base.Set(propertyName, value);
        }

        #endif

        #if NET45
 
        internal new bool SetProperty<T>(ref T storage, T value, [CallerMemberName] string propertyName = null)
        {
            base.SetProperty(ref storage, value, propertyName);
        }
 
        #endif

        #endregion

        internal new void Dispose()
        {
            base.Dispose();
        } 
    }
}