﻿using NUnit.Framework;

namespace SmallMvvm.Core.UnitTests.Property._ExtendedPropertyBase
{
    [TestFixture]
    public class GetSetFixture
    {
        [Test]
        public void Usage()
        {
            ExtendedPropertyTestClass instance = new ExtendedPropertyTestClass();
            instance.Set("SomeProperty", "SomeValue");

            Assert.That(instance.Get("SomeProperty", "123"), Is.EqualTo("SomeValue"));  
        }

        [Test]
        public void UsageWithExpression()
        {
            string str = string.Empty;

            ExtendedPropertyTestClass instance = new ExtendedPropertyTestClass();
            instance.Set(() => str, "SomeValue");

            Assert.That(instance.Get(() => str, "123"), Is.EqualTo("SomeValue"));  
        }

        [Test]
        public void UsageWithoutSet()
        {
            string str = string.Empty;

            ExtendedPropertyTestClass instance = new ExtendedPropertyTestClass();
            Assert.That(instance.Get(() => str, "123"), Is.EqualTo("123"));  
        }

        [Test]
        public void UsageAfterDispose()
        {
            string str = string.Empty;

            ExtendedPropertyTestClass instance = new ExtendedPropertyTestClass();
            instance.Set(() => str, "SomeValue");
            instance.Dispose();

            Assert.That(instance.Get(() => str), Is.Null);
        }
    }
}