using System;
using System.Linq.Expressions;
using SmallMvvm.Core.Property;

namespace SmallMvvm.Core.UnitTests.Property._PropertyChangedBase
{
    internal class PropertyChangedTestClass : PropertyChangedBase
    {
        #if NET45

        internal new virtual void OnPropertyChanged([CallerMemberName] string propertyName = null)
        {
            base.OnPropertyChanged(propertyName);
        }

        #else

        internal new virtual void OnPropertyChanged(string propertyName)
        {
            base.OnPropertyChanged(propertyName);
        }

        #endif

        internal new virtual void MultipleOnPropertyChanged(string[] propertys)
        {
            base.MultipleOnPropertyChanged(propertys);
        }

        #if !NET20 && !NET30

        internal new virtual void OnPropertyChanged<T>(Expression<Func<T>> expression)
        {
            base.OnPropertyChanged(expression);
        }

        internal new virtual void MultipleOnPropertyChanged<T>(Expression<Func<T>>[] expressions)
        {
            base.MultipleOnPropertyChanged(expressions);
        }

        internal new string GetPropertyName<T>(Expression<Func<T>> expression)
        {
            return base.GetPropertyName(expression);
        }

        #endif
    }
}