﻿using System;
using System.Globalization;
using System.Text;

namespace SmallMvvm.Core.Datatypes
{
    public static class StringExtensions
    {
         public static string Reverse(this string str)
         {
            char[] array = str.ToCharArray();
            char[] arrayReverse = new char[array.Length];

            int counter = 0;
            for (int i = array.Length - 1; i >= 0; i--)
            {
                arrayReverse[counter] = array[i];
                counter++;
            }

            return new string(arrayReverse);
         }

        public static string EncodeToBase64(this string str, string encoding = "UTF-8")
        {
            Encoding encode = Encoding.GetEncoding(encoding);
            byte[] bytes = encode.GetBytes(str);

            return Convert.ToBase64String(bytes);
        }

        public static string DecodeFromBase64(this string str, string encoding = "UTF-8")
        {
            Encoding encode = Encoding.GetEncoding(encoding);
            byte[] bytes = Convert.FromBase64String(str);

            return encode.GetString(bytes);
        }

        public static bool IsNumeric(this string str)
        {
            decimal d;
            return decimal.TryParse(str, NumberStyles.Any, NumberFormatInfo.InvariantInfo, out d);
        }

        public static bool IsInt32(this string str)
        {
            int d;
            return int.TryParse(str, NumberStyles.Any, NumberFormatInfo.InvariantInfo, out d);
        }
    }
}