using NUnit.Framework;
using SmallMvvm.Services.Exceptions;

namespace SmallMvvm.Services.UnitTests._ServiceProvider
{
    [TestFixture]
    public class GetServiceFixture
    {
        [Test]
        public void GetUsage()
        {
            IServiceProvider serviceProvider = new ServiceProvider();
            serviceProvider.Register<ITestServiceA>(new TestServiceA());

            ITestServiceA testServiceA = serviceProvider.GetService<ITestServiceA>();
            Assert.That(testServiceA.Name, Is.EqualTo("Service A"));  
        }

        [Test]
        public void FailToGetUnregisteredService()
        {
            IServiceProvider serviceProvider = new ServiceProvider();

            ServiceNotAvailableException exception = Assert.Throws<ServiceNotAvailableException>(() => serviceProvider.GetService<ITestServiceA>());
            Assert.That(exception.GetType(), Is.EqualTo(typeof(ServiceNotAvailableException)));  
        }
    }
}