using NUnit.Framework;
using SmallMvvm.Services.Exceptions;

namespace SmallMvvm.Services.UnitTests._ServiceProvider
{
    [TestFixture]
    public class UnregisterServiceFixture
    {
        [Test]
        public void UnregisterUsage()
        {
            IServiceProvider serviceProvider = new ServiceProvider();
            serviceProvider.Register<ITestServiceA>(new TestServiceA());

            ITestServiceA testServiceA = serviceProvider.GetService<ITestServiceA>();
            Assert.That(testServiceA.Name, Is.EqualTo("Service A"));  

            serviceProvider.Unregister<ITestServiceA>();

            ServiceNotAvailableException exception = Assert.Throws<ServiceNotAvailableException>(serviceProvider.Unregister<ITestServiceA>);
            Assert.That(exception.GetType(), Is.EqualTo(typeof(ServiceNotAvailableException)));
            Assert.That(exception.Message, Is.EqualTo(string.Format("Named service '{0}' of type '{1}' is not available!", typeof(ITestServiceA).FullName, typeof(ITestServiceA))));  
        }
    }
}