using System;
using SmallMvvm.Services.Properties;

namespace SmallMvvm.Services.Exceptions
{
    public class ServiceNotAvailableException : ServiceException
    {
        public string ServiceName { get; private set; }
        public Type Type { get; private set; }

        public override string Message
        {
            get { return BuildExceptionMessage(); }
        }

        public ServiceNotAvailableException(Type type)
            : this("", type)
        { }

        public ServiceNotAvailableException(string serviceName, Type type)
        {
            ServiceName = serviceName;
            Type = type;
        }

        private string BuildExceptionMessage()
        {
            if (string.IsNullOrEmpty(ServiceName) && Type == null)
                return base.Message;

            if (Type != null && string.IsNullOrEmpty(ServiceName))
                return string.Format(Resources.ServiceNotAvailableException_ServiceTypeNotAvailable, Type);

            return string.Format(Resources.ServiceNotAvailableException_NamedServiceNotAvailable, ServiceName, Type);
        }
    }
}