using System;

namespace SmallMvvm.Services
{
    public interface IServiceProvider : System.IServiceProvider
    {
        object GetService(Type serviceType, string serviceName);

        T GetService<T>() where T : class;
        T GetService<T>(string serviceName) where T : class;

        void Register<T>(T instance) where T : class;
        void Register<T>(T instance, string serviceName) where T : class;

        void Unregister<T>() where T : class;
        void Unregister<T>(string serviceName) where T : class;

        void UnregisterAll();
    }
}